require "defines"


--inventory_initializer = 1
chestLimit = 3


script.on_init(function()
end)

script.on_load(function()
end)

script.on_configuration_changed(function()
	for key, player in pairs(game.players) do 
		-- since I'm not sure if table key is the same as player_index.
		if game.players[player.index].gui.left.bt_sort then
			--destroy v 0.0.1 button
			game.players[player.index].gui.left.bt_sort.destroy()
		end
		
		if game.players[player.index].gui.left.bt_fill then
			--destroy v 0.0.1 test button
			game.players[player.index].gui.left.bt_fill.destroy()
		end
		
		--- ### recreate interface (just in case) ####
		if game.players[player.index].gui.left.sort_inventory then
			game.players[player.index].gui.left.sort_inventory.destroy()
		end
		init(player.index)
		--- ####################################
	end
end)


script.on_event(defines.events.on_player_created, function(event)
	init(event.player_index)
end)
	

script.on_event(defines.events.on_tick, function(event)
--	if inventory_initializer == 1 then
--		init()
--	end
end)

function init(player_index)
	--inventory_initializer = 0
	if game.players[player_index].gui.left.bt_sort then
		game.players[player_index].gui.left.bt_sort.destroy()
		--game.players[1].gui.left.bt_fill.destroy()
	end
	
	if not game.players[player_index].gui.left.bt_sort then
		game.players[player_index].gui.left.add{type="flow", name = "sort_inventory"}
		game.players[player_index].gui.left.sort_inventory.add{type="button", name = "bt_sort", caption = "S", style = "myButton"}
		--game.player.print("add ")
		--game.players[player_index].gui.left.add{type="button", name = "bt_fill", caption = "F", style = "myButton"}
	end
end


script.on_event(defines.events.on_gui_click, function(event)
	
	local p_index = event.player_index

	if event.element.name == "bt_sort" then
		sortInventory(p_index)
	end

	-- for testing purpose
	--[[
	if event.element.name == "bt_fill" then
		local inventory = game.players[p_index].get_inventory(defines.inventory.player_main)
		if inventory then
			--for i=1, 50 do
			--	inventory.insert("iron-plate")
			--end
			inventory.insert({name="car",count=1})
			inventory.insert({name="coal",count=100})
		end
	end
	--]]
	
	
end)

function checkChestEmpty(chests)
	for i=1, chestLimit do
		if not chests[i].get_inventory(defines.inventory.chest).is_empty() then
			return false
		end
	end
	return true
end

function sortInventory(p_index)
		
	local inventory = game.players[p_index].get_inventory(defines.inventory.player_main)
	if inventory then
		--debugInfo = ""
		if inventory.is_empty() then return end

		-- create chestLimit fake chest to store temporary player pockets content
		myfakechest = {}
		for c=1,chestLimit do 
			myfakechest[c] = game.surfaces["nauvis"].create_entity {
			name = "steel-chest",
			position = {game.players[p_index].position.x,game.players[p_index].position.y},
			force = game.players[p_index].force}
		end
		
		-- move inventory to chest(s), -> auto stack with API method LuaEntity:insert() 
		inventorySize = #inventory		
		for i=1, inventorySize do
			if inventory[i].valid_for_read then
				for c=1, chestLimit do
				 -- invetory[i] is a LuaItemStack, must be here because removing items cause it to be non valid when 0 is reached
					chestInventory = myfakechest[c].get_inventory(defines.inventory.chest)
					if inventory[i].prototype.item_to_clear or inventory[i].has_grid then -- we have a blueprint
						for ch=1, #chestInventory do
							if not chestInventory[ch].valid_for_read then
								if chestInventory[ch].can_set_stack(inventory[i]) then
									--game.player.print("can set on " .. ch)
									chestInventory[ch].set_stack(inventory[i])
									inventory[i].clear()
									break
								end
							end
						end
					else
						if inventory[i].count > 0 and chestInventory.can_insert(inventory[i]) then
						--game.player.print("setup")
							local nb = chestInventory.insert(inventory[i])
							inventory[i].count = inventory[i].count - nb
						end
					end
					if not inventory[i].valid_for_read then break end
					if inventory.is_empty() then break end
				end
			end	
		end
		
		
		--move chests to inventory
		z=0 -- infinite loop failsafe
		repeat --until all chest are empty, remove one type of item at a time for every chest (non placeable)
			z = z+1
			local currentItem = nil
			for c=1,chestLimit do 
				if not myfakechest[c].get_inventory(defines.inventory.chest).is_empty() then
					chestInventory = myfakechest[c].get_inventory(defines.inventory.chest)
					chestInventorySize = #chestInventory
					--get first
					for i=1, chestInventorySize do
						moveItem = false
						if chestInventory[i].valid_for_read then
							--game.player.print("valid for read  c:" .. c.." i:"..i .. " ".. chestInventory[i].prototype.name)
							--non placeable objects first (materials)
							if chestInventory[i].prototype.place_result == nil then
								if chestInventory[i].prototype.item_to_clear or chestInventory[i].has_grid then -- we have a blueprint
									for inv=1, inventorySize do
										if not inventory[inv].valid_for_read then
											if inventory[inv].can_set_stack(chestInventory[i]) then
												--game.player.print("can set on player " .. inv)
												inventory[inv].set_stack(chestInventory[i])
												chestInventory[i].clear()
												break
											end
										end
									end
									
								else
									if not currentItem 	then --first item found
										currentItem = chestInventory[i].prototype.name
										moveItem = true
									elseif currentItem == chestInventory[i].prototype.name then
										moveItem = true
									end
									if moveItem then
										inventory.insert(chestInventory[i])
										chestInventory[i].clear()
									end
								end
								if chestInventory.is_empty() then break end
							end
							
							--debugInfo = "type :" .. chestInventory[i].prototype.type .. " name : "..chestInventory[i].prototype.name .. "placable : " ..tostring()
						end
					end
				end
			end
		until checkChestEmpty(myfakechest) or z == 1000
		
		z=0
		repeat --until all chest are empty, remove one type of item at a time for every chest (placeable items)
			z = z+1
			local currentItem = nil
			for c=1,chestLimit do
				if not myfakechest[c].get_inventory(defines.inventory.chest).is_empty() then
					chestInventory = myfakechest[c].get_inventory(defines.inventory.chest)
					chestInventorySize = #chestInventory
					--get first
					for i=1, chestInventorySize do
						moveItem = false
						if chestInventory[i].valid_for_read then
							--placeable objects (inserter, miners, turret, belt...)
							if chestInventory[i].prototype.place_result then
								if not currentItem 	then --first item found
									currentItem = chestInventory[i].prototype.name
									moveItem = true
								elseif currentItem == chestInventory[i].prototype.name then
									moveItem = true
								end
								if moveItem then
									inventory.insert(chestInventory[i])
									chestInventory[i].clear()
								end
							end
							if chestInventory.is_empty() then break end
						end
					end
				end
			end
		until checkChestEmpty(myfakechest) or z == 1000
		
		
		for c=1,chestLimit do 
			-- remove sorting chest if empty. otherwise, keep them to avoid item loss
			if myfakechest[c].get_inventory(defines.inventory.chest).is_empty() then myfakechest[c].destroy() end
		end
	end
end
--[[
function myDebug(pstring)
	game.players[p_index].gui.left.debug.caption = pstring .. " ".. game.tick
end
--]]	
	